/*************************************************************
  JetiBox Bedienung
  
  include aus Main
  ------------------------------------------------------------
  
  Copyright (C) 2017 Thomas Lehmann
  
  Version history:
  1.00   05.12.2017  created

***************************************************************/





// ====
// Menu
// ====
enum
  {
  MP_MAIN,                  // Eintritt
  MP_SAVE,                  // Konfig geändert, speichern/verwerfen
  MP_SETUP,
   MP_RPM_A,                // Drehzahl
    MP_RPM_RELCNT,          // # Auslösungen je Umdrehung
    MP_RPM_ACCURACY,        // Glättung, RPM Genauigkeit
   MP_FUEL_A,               // Spritverbtrauch
    MP_FUEL_VOL,            // Tankgröße
    MP_FUEL_RES,            // Volume Reset, man/auto
    MP_FUEL_CNT,            // # Impulse je Liter
    MP_FUEL_CAL,            // # Impulse je Liter kalibrieren
   MP_TEMP,                 // Temperatur
    MP_TEMP1_A,             // Sensor 1 aktivieren
    MP_TEMP2_A,             // Sensor 2 aktivieren
    MP_TEMP3_A,             // Sensor 3 aktivieren
    MP_TEMP4_A,             // Sensor 4 aktivieren
    MP_TEMP5_A,             // Sensor 5 aktivieren
    MP_TEMP6_A,             // Sensor 6 aktivieren
    MP_TEMP7_A,             // Sensor 7 aktivieren
      #if CNT_SENS_TEMP != 7
      hier ist was faul
      #endif
   MP_ALT_A,                // Höhe
    MP_ALT_TEMP_A,          // Umgebungstemperatur
    #if _BMP180_  == 1
    MP_ALT_TYP,             // Sensor Typ
    #else
    #define MP_ALT_TYP  0xff
    #endif
   MP_GPS,                  // GPS
    MP_GPS_POS_A,           // Position, Latitude+Longitude aktivieren
    MP_GPS_ALT_A,           // Höhe aktivieren
    MP_GPS_SPEED_A,         // Speed+Speed max. aktivieren
    MP_GPS_DIST_TO_A,       // Entfernung + Richtung zum Modell aktivieren
    MP_GPS_TRIP_A,          // zurückgelegte Strecke und Gesamstrecke aktivieren
    MP_GPS_SATS_A,          // # Sateliten
   #if _SENS_ACC_ == 1
   MP_ACC,                  // Acceleration
    MP_ACC_GFORCE,          // G-Force X/Y/Z Achse
    MP_ACC_CAL,             // G-Force X/Y/Z Achse Kalibrieren
    MP_ACC_PITCH,           // Pitch
    MP_ACC_ROLL,            // Roll
   #endif

  MP_SERV,                  // Service, allg. Info
    MP_SERV_FRES,           // verbrauchte Tankmenge zurücksetzen
    MP_SERV_FAC,            // auf default Werte setzten
    MP_SERV_RES_RTIM,       // Laufzeit zurücksetzen
    MP_SERV_RES_REVOL,      // Gesamt Umdrehungen zurücksetzen
    MP_SERV_RES_FUEL,       // Gesamt Verbrauch zurücksetzen
    MP_SERV_RES_DIST,       // Gesamt Distanz zurücksetzen
    MP_SERV_INFO,           // Info

//  MP_DEBUG,
  };


const struct S_MENU
  {
  uint8_t PosLeft;
  uint8_t PosRight;
  uint8_t PosDown;
  uint8_t PosUp;
  char    Zeile1[17];
  }Menu[] PROGMEM =
    {
    // -----------------------------------------------------------------------------------------------
    // Menuaufbau
    // ----------
    //   0.0 MP_MAIN
    //   " XSensor by ThL"
    //   "V1.00 12.06.2016"
    //
    //   1.0 Setup                                                                                 2.0 Service
    //                                                                                             2.1 Fuel Volume Reset
    //                                                                                             2.2 Factory defaults
    //                                                                                             2.3 Info
    //                                                                                             2.4 Res Revolution
    //                                                                                             2.5 Res Runtime
    //                                                                                             2.6 Res Fuel tot
    //                                                                                             2.6 Res Dist tot
    //                                                                                             2.6 Res Speed max
    //                                                                                             2.7 Debug
    //   1.0 RPM       2.0 Fuel       3.0 TEMP         4.0 Alt     5.0 GPS             6.0 Acc
    //   1.1 RelCnt    2.1 Volume     3.1 Temp1 activ  4.1 Temp    5.1 Pos activ       6.1 GForce X/Y/Z
    //   1.2 Accuracy  2.2 Volume Res 3.2 Temp2 activ  4.2 Typ     5.2 Alt activ       6.2 calib GForce
    //                 2.3 #Imp/L     3.3 Temp3 activ              5.3 Speed activ     6.3 Pitch
    //                 2.4 calibrier  3.4 Temp4 activ              5.4 Dist-To activ   6.4 Roll
    //                                3.5 Temp5 activ              5.5 Dist Trip activ     
    //                                3.6 Temp6 activ              5.6 Sats activ
    //                                3.7 Temp7 activ
    //
    // -----------------------------------------------------------------------------------------------
    // left             right             down              up                 1234567890123456          MenuIdx
    { MP_MAIN,          MP_MAIN,          MP_SETUP,         MP_MAIN,           JB_TEXT_Z1,        },  // MP_MAIN
    { 0xff,             0xff,             0xff,             0xff,             "config changed  ", },  // MP_SAVE

    { MP_SERV,          MP_SERV,          MP_RPM_A,         MP_MAIN,          "Setup           ", },  // MP_SETUP

    { 0xff,             MP_FUEL_A,        MP_RPM_RELCNT,    MP_SETUP,         "10 Sensor RPM <>", },  // MP_RPM_A
    { 0xff,             0xff,             MP_RPM_ACCURACY,  MP_RPM_A,         "11 Release Cnt >", },  //  MP_RPM_RELCNT
    { 0xff,             0xff,             0xff,             MP_RPM_RELCNT,    "12 Accuracy    >", },  //  MP_RPM_ACCURACY

    { MP_RPM_A,         MP_TEMP,          MP_FUEL_VOL,      MP_SETUP,         "20 Sensor Fuel<>", },  // MP_FUEL_A
    { 0xff,             0xff,             MP_FUEL_RES,      MP_FUEL_A,        "21 Fuel volume >", },  // MP_FUEL_VOL
    { 0xff,             0xff,             MP_FUEL_CNT,      MP_FUEL_VOL,      "22 Volume Reset>", },  // MP_FUEL_RES
    { 0xff,             0xff,             MP_FUEL_CAL,      MP_FUEL_RES,      "<  23 pulse/L  >", },  // MP_FUEL_CNT
    { 0xff,             0xff,             0xff,             MP_FUEL_CNT,      "24 cal pulse/L<>", },  // MP_FUEL_CAL

    { MP_FUEL_A,        MP_ALT_A,         MP_TEMP1_A,       MP_SETUP,         "30 Sensor Temp  ", },  // MP_TEMP
    { 0xff,             0xff,             MP_TEMP2_A,       MP_TEMP,          "31 Sens Temp1 <>", },  //  MP_TEMP1_A
    { 0xff,             0xff,             MP_TEMP3_A,       MP_TEMP1_A,       "32 Sens Temp2 <>", },  //  MP_TEMP2_A
    { 0xff,             0xff,             MP_TEMP4_A,       MP_TEMP2_A,       "33 Sens Temp3 <>", },  //  MP_TEMP3_A
    { 0xff,             0xff,             MP_TEMP5_A,       MP_TEMP3_A,       "34 Sens Temp4 <>", },  //  MP_TEMP4_A
    { 0xff,             0xff,             MP_TEMP6_A,       MP_TEMP4_A,       "35 Sens Temp5 <>", },  //  MP_TEMP5_A
    { 0xff,             0xff,             MP_TEMP7_A,       MP_TEMP5_A,       "36 Sens Temp6 <>", },  //  MP_TEMP6_A
    { 0xff,             0xff,             0xff,             MP_TEMP6_A,       "38 Sens Temp7 <>", },  //  MP_TEMP7_A

    { MP_TEMP,          MP_GPS,           MP_ALT_TEMP_A,    MP_SETUP,         "40 Sensor Alt <>", },  // MP_ALT_A
    { 0xff,             0xff,             MP_ALT_TYP,       MP_ALT_A,         "41 Sens temp  <>", },  // MP_ALT_TEMP_A
    #if _BMP180_  == 1
    { 0xff,             0xff,             0xff,             MP_ALT_TEMP_A,    "42 Sens Typ    >", },  // MP_ALT_TYP
    #endif

    #if _SENS_GPS_ == 1
//  { MP_ALT_A,         MP_ACC,           MP_GPS_POS_A,     MP_SETUP,         "50 Sensor GPS   ", },  // MP_GPS
    { MP_ALT_A,         0xff,             MP_GPS_POS_A,     MP_SETUP,         "50 Sensor GPS   ", },  // MP_GPS
    { 0xff,             0xff,             MP_GPS_ALT_A,     MP_GPS,           "51 Sens Pos   <>", },  //  MP_GPS_POS_A
    { 0xff,             0xff,             MP_GPS_SPEED_A,   MP_GPS_POS_A,     "52 Sens Alt   <>", },  //  MP_GPS_ALT_A
    { 0xff,             0xff,             MP_GPS_DIST_TO_A, MP_GPS_ALT_A,     "53 Sens Speed <>", },  //  MP_GPS_SPEED_A
    { 0xff,             0xff,             MP_GPS_TRIP_A,    MP_GPS_SPEED_A,   "54 Sens DistTo<>", },  //  MP_GPS_DIST_A
    { 0xff,             0xff,             MP_GPS_SATS_A,    MP_GPS_DIST_TO_A, "55 Sens Trip  <>", },  //  MP_GPS_TRIP_A
    { 0xff,             0xff,             0xff,             MP_GPS_TRIP_A,    "56 Sens Sats  <>", },  //  MP_GPS_SATS_A
    #endif

    #if _SENS_ACC_ == 1
    { MP_GPS,           0xff,             MP_ACC_GFORCE,    MP_SETUP,         "60 Sensor Accel ", },  // MP_ACC
    { 0xff,             0xff,             MP_ACC_CAL,       MP_ACC,           "61 Sens GForce<>", },  //  MP_ACC_GFORCE
    { 0xff,             0xff,             MP_ACC_PITCH,     MP_ACC_GFORCE,    "62 calib GForc<>", },  //  MP_ACC_CAL
    { 0xff,             0xff,             MP_ACC_ROLL,      MP_ACC_CAL,       "63 Sens Pitch <>", },  //  MP_ACC_PITCH
    { 0xff,             0xff,             0xff,             MP_ACC_PITCH,     "64 Sens Roll  <>", },  //  MP_ACC_ROLL
    #endif
    
    { MP_SETUP,         MP_SETUP,         MP_SERV_FRES,     MP_MAIN,          "Service         ", },  // MP_SERVICE
    { 0xff,             0xff,             MP_SERV_FAC,      MP_SERV,          "volume reset  <>", },  //  MP_SERV_FRES
    { 0xff,             0xff,             MP_SERV_RES_RTIM, MP_SERV_FRES,     "factory def.  <>", },  //  MP_SERV_FAC
    { 0xff,             0xff,             MP_SERV_RES_REVOL,MP_SERV_FAC,      "Res Runtime   <>", },  //  MP_SERV_RES_RTIM
    { 0xff,             0xff,             MP_SERV_RES_FUEL, MP_SERV_RES_RTIM, "Res Revolution<>", },  //  MP_SERV_RES_REVOL
    { 0xff,             0xff,             MP_SERV_RES_DIST, MP_SERV_RES_REVOL,"Res Fuel tot  <>", },  //  MP_SERV_RES_FUEL
    { 0xff,             0xff,             MP_SERV_INFO,     MP_SERV_RES_FUEL, "Res Dist tot  <>", },  //  MP_SERV_RES_DIST
    { 0xff,             0xff,             0xff,             MP_SERV_RES_DIST, " (c) Th.Lehmann ", },  //  MP_SERV_INFO
//    { 0xff,             0xff,             MP_DEBUG,         MP_SERV_FAC,      " (c) Th.Lehmann ", },  //  MP_SERV_INFO
//    { 0xff,             0xff,             0xff,             MP_SERV_INFO,     "Debug           ", },  //  MP_DEBUG
    };




// =======================
// JetiBox Tasten bewerten
// =======================
#define JBKEY_UP      0xd0
#define JBKEY_DOWN    0xb0
#define JBKEY_LEFT    0x70
#define JBKEY_RIGHT   0xe0
#define JBKEY_LR      0x60
#define JBKEY_UD      0x90
#define JBKEY_REFRESH 0xFF

void HandleJB( bool Refresh )
{
 static uint8_t MenuIdx, Idx;
 static bool FuelCalActiv; 
 uint8_t MenuNxt;
 uint8_t Key;
 int8_t  IdActiv = -1;
 struct S_MENU MenuCpy;
 char    JB_Buff[17];                        // JB Ausgabe, Zeile 1/2
  #define  JBPOS_TXT  8                      // kleiner Text (5Ch 8-12)
  #define  JBPOS_CHK  15                     // Pos Sensortestausgabe in Zeile 2
  #define  JBPOS_INIT 14                     // Pos Init Fehler in Zeile 2
  #define  JBPOS_FAIL 15                     // Pos Ausfall in Zeile 2
 bool ErrFail = false;
 uint32_t *NV_Val;
 const char *Txt = 0;

/*
 #define  JBPOS_TEST 14                     // Pos Sensor Test in Zeile 2
 char SensTstCh = 0;                         // Sensor Funktionstest
*/

  if( Refresh )
    Key = JBKEY_REFRESH;                     // Aufruf um Anzeige zu aktualisieren
  else
    #if HW_TERM == 1
    Key = ConGetKey();                       // liefert 0 wenn nichts gedrückt
    #elif SOFT_TERM == 1
    Key = 
    #else
    // JB Empfang, Sender liefert zu schnell Tastenwiederholungen wenn schon etwas zu lange gedrückt
    if( (Key = JetiEx.GetJetiboxKey()) != 0 ) // liefert 0 wenn nichts gedrückt
      {
      static uint32_t LastKeyMS;
      if( millis() < LastKeyMS )
        return;
      LastKeyMS = millis() + 300;
      SensorChk.Id = 0;                      // Sensor Funktionstest ggf. ausschalten
      } 
    #endif
  if( Key == 0 )
    return;


#if SOFT_TERM == 1
  sprintf(TermBuff, "%02x", Key);
  TermPut(TermBuff);
#endif


  // akt. Eintrag für Zugriff aus Flash ins RAM kopieren
  memcpy_P( &MenuCpy, &Menu[MenuIdx], sizeof(MenuCpy) );
  switch( Key )
    {
    case JBKEY_LEFT:                // links
      MenuNxt = MenuCpy.PosLeft;
      break;
    case JBKEY_RIGHT:               // rechts
      MenuNxt = MenuCpy.PosRight;
      break;
    case JBKEY_DOWN:                // runter
      MenuNxt = MenuCpy.PosDown;
      break;
    case JBKEY_UP:                  // hoch
      MenuNxt = MenuCpy.PosUp;
      break;

    case JBKEY_LR:                  // links+rechts
    case JBKEY_UD:                  // Hoch+Runter
    case JBKEY_REFRESH:
      MenuNxt = 0xff;
      break;
    default:
      return;
    }
  if( MenuNxt != 0xff )            // hier verweilen ?
    {
    MenuIdx = MenuNxt;             // nö, zum nächsten Menu springen
    FuelCalActiv = false;          // FuelFlow Kalibrierung ohne speichern beenden, Cal-Menue verlassen
    }



  JB_Buff[sizeof(JB_Buff)-1] = 0;  // Strg Ende nur für TermPut() notwendig
  // Menutext Zeile 1
  memcpy_P( JB_Buff, &Menu[MenuIdx].Zeile1, 16 );
  JetiEx.SetJetiboxText( JetiExProtocol::LINE1, JB_Buff );


  memset( JB_Buff, ' ', sizeof(JB_Buff)-1 );
  switch( MenuIdx )
    {
    case MP_MAIN:    
      strcpy( JB_Buff, JB_TEXT_Z2);
      if( EEpromSave )                       // bei Austritt fragen ob Änderungen gespeichert werden sollen
        {
        MenuIdx = MP_SAVE;                   // Konfig geändert, speichern / verwerfen
        HandleJB( true );
        return;
        }
      break;

    case MP_SAVE:      // 1234567890123456
        strcpy( JB_Buff, "\x12 exit / save <>");
        if( Key == JBKEY_REFRESH )
          break;
        if( Key == JBKEY_LR )               // Rechts+Links > Änderungen speichern
          EEpromRW( true );
        else if( Key != JBKEY_UD )          // Hoch+Runter > Änderungen verwerfen / Reset
          break;
        SoftReset();                        // Neustart mit geänderter oder alter Konfig
      break;


    case MP_SETUP:
    case MP_SERV:
    case MP_TEMP:
      break;
    #if _SENS_GPS_ == 1
    case MP_GPS:
      if( SensGps )
        ErrFail = SensGps->Failure;
      break;
    #endif
    #if _SENS_ACC_ == 1
    case MP_ACC:
      //SensAcc->Failure
      break;
    #endif
 

    // Service
    // -------
    case MP_SERV_FRES:                // Reset entnommene Menge
      if( Key == JBKEY_LR )
        { // !! EEprom wird beschrieben, bisherige Änderungen übernommen, deshalb nur löschbar wenn nichts geändert wurde !!
        if( !EEpromSave && SensFuel )
          {
          SensFuel->ResetFlowCntTank();
          EEpromRW( true );
          }
        }
                      // 1234567890123456
      sprintf( JB_Buff, "fuel %lumL", SensFuel->TVal.VolumeRemain);
      break;

    case MP_SERV_RES_RTIM:          // Laufzeit zurücksetzen
      NV_Val = &EEprom.NV.RpmRunTimeS;
      goto RESET_NV_VAL;
    case MP_SERV_RES_REVOL:         // Gesamt Umdrehungen zurücksetzen
      NV_Val = &EEprom.NV.RpmRevolTot;
      goto RESET_NV_VAL;
    case MP_SERV_RES_FUEL:          // Gesamt Verbrauch zurücksetzen
      NV_Val = &EEprom.NV.FuelFlowCntTot;
      goto RESET_NV_VAL;
    case MP_SERV_RES_DIST:          // Gesamt Distanz zurücksetzen
      NV_Val = &EEprom.NV.GpsDistTot;
RESET_NV_VAL:
                      // 1234567890123456
      sprintf( JB_Buff, "%lu", *NV_Val);
      if( Key == JBKEY_LR )
        {
        *NV_Val = 0L;
        EEpromSave = true;
        }
      break;



    case MP_SERV_FAC:
      if( Key == JBKEY_LR )
        {             // 1234567890123456
        strcpy(JB_Buff, "set to default");
        EEprom.Data.Magic = 0xffff;
        EEpromRW( true );
        SoftReset();
        }
      break;
    case MP_SERV_INFO:
                    // 1234567890123456
      strcpy(JB_Buff, " thomas@thls.de");
      break;
//    case MP_DEBUG:
//      sprintf(JB_Buff, "free RAM:%u", freeRam());
//      break;


    // Sensoren akt/deaktivieren
    // -------------------------
    case MP_RPM_A:
      IdActiv = ID_RPM;
      if( Key == JBKEY_LR )      // Änderung ?
        {
        BIT_TGL( EEprom.Data.SensActivMsk, ID_RPM_REVOL );
        BIT_TGL( EEprom.Data.SensActivMsk, ID_RPM_RUNTIME );
        }
      SensorChk.Id = ID_RPM;      // Sensorcheck aktiv, Änderungen anzeigen
      break;

    case MP_TEMP1_A ... MP_TEMP7_A:
      {
      const char *TypTxt[] = STYP_TEMP_TXT;

      Idx = MenuIdx - MP_TEMP1_A;
      IdActiv = ID_TEMP1 + Idx;
      if( Key == JBKEY_RIGHT )    // zwischen NTC und IR Sensor wechseln
        {
        if( Idx < CNT_SENS_TEMP_NTC )     // nur 4 NTC aber 7 IR
          {
          EEprom.Data.CfgSensTypTemp[Idx] ^= 1;
          EEpromSave = true;
          }
        }
      Txt = TypTxt[EEprom.Data.CfgSensTypTemp[Idx]];

      if( SensTemp[Idx] )
        ErrFail = SensTemp[Idx]->Failure;
      break;
      }

    case MP_ALT_A:
      IdActiv = ID_ALT_REL;
      //SensAlt->Failure
      break;
    case MP_ALT_TEMP_A:
      IdActiv = ID_ALT_TEMP;
      break;

    case MP_FUEL_A:
      IdActiv = ID_FUEL_VOL;
      if( Key == JBKEY_LR )      // Änderung ?
        {
        BIT_TGL( EEprom.Data.SensActivMsk, ID_FUEL_VOL_PROZ  );
        BIT_TGL( EEprom.Data.SensActivMsk, ID_FUEL_FLOW  );
        BIT_TGL( EEprom.Data.SensActivMsk, ID_FUEL_TOT );
        }
      SensorChk.Id = ID_FUEL_FLOW;  // Sensorcheck aktiv, Änderungen anzeigen
      break;

    #if _SENS_GPS_ == 1
    case MP_GPS_POS_A:           // Position Latitude+Longitude aktivieren
      IdActiv = ID_GPS_LAT;
      if( Key == JBKEY_LR )      // Änderung ?
        BIT_TGL( EEprom.Data.SensActivMsk, ID_GPS_LON );
      break;
    case MP_GPS_ALT_A:           // Höhe aktivieren
      IdActiv = ID_GPS_ALT;
      break;
    case MP_GPS_SPEED_A:         // Speed+max. aktivieren
      IdActiv = ID_GPS_SPEED;
      if( Key == JBKEY_LR )      // Änderung ?
        BIT_TGL( EEprom.Data.SensActivMsk, ID_GPS_SPEED_MAX );
      break;
    case MP_GPS_DIST_TO_A:       // Entfernung aktivieren
      IdActiv = ID_GPS_DIST_TO;
      if( Key == JBKEY_LR )      // Änderung ?
        {
        BIT_TGL( EEprom.Data.SensActivMsk, ID_GPS_COURSE );
        BIT_TGL( EEprom.Data.SensActivMsk, ID_GPS_HEAD );
        }
      break;
    case MP_GPS_TRIP_A:           // zurückgelegte Strecke aktivieren
      IdActiv = ID_GPS_DIST_TRIP;
      if( Key == JBKEY_LR )      // Änderung ?
        BIT_TGL( EEprom.Data.SensActivMsk, ID_GPS_DIST_TOT );
      break;
    case MP_GPS_SATS_A:          // # Sateliten
      IdActiv = ID_GPS_SATS;
      break;
    #endif

    #if _SENS_ACC_ == 1
    case MP_ACC_GFORCE:          // G-Force X/Y/Z Achse
      IdActiv = ID_ACC_GFORCE_X;
      if( Key == JBKEY_LR )      // Änderung ? G-Force immer für alle Achsen
        {
        BIT_TGL( EEprom.Data.SensActivMsk, ID_ACC_GFORCE_Y );
        BIT_TGL( EEprom.Data.SensActivMsk, ID_ACC_GFORCE_Z );
        }
      break;
    case MP_ACC_CAL:             // G-Force X/Y/Z Achse Kalibrieren
      // G-Force nicht aktiv, Calib überspringen 
      if( !BIT_TST(EEprom.Data.SensActivMsk, ID_ACC_GFORCE_X) )
        {               // 1234567890123456
        sprintf( JB_Buff, "not available");
        }
      break;

    case MP_ACC_PITCH:           // Pitch
      IdActiv = ID_ACC_PITCH;
      break;
    case MP_ACC_ROLL:            // Roll
      IdActiv = ID_ACC_ROLL;
      break;
    #endif


    // RPM Sensor
    // ----------
    case MP_RPM_RELCNT:           // # Auslösungen je Umdrehung
      if( Key == JBKEY_RIGHT )
        {
        EEprom.Data.RpmCfgCntMag ^= 1;
        EEpromSave = true;
        }
                      // 1234567890123456
      sprintf( JB_Buff, "%u / revolution", EEprom.Data.RpmCfgCntMag+1);
      break;

    case MP_RPM_ACCURACY:        // RPM Anzeige, Genauigkeit n UPM
      if( Key == JBKEY_RIGHT )
        {
        EEprom.Data.RpmCfgAccuracy += 10;
        if( EEprom.Data.RpmCfgAccuracy > RPM_ACCURACY_MAX )
          EEprom.Data.RpmCfgAccuracy = 0;
        EEpromSave = true;
        }
                      // 1234567890123456
      sprintf( JB_Buff, "%u RPM/min", EEprom.Data.RpmCfgAccuracy ? EEprom.Data.RpmCfgAccuracy : 1);
      break;


    // Durchfluss Sensor
    // -----------------
    case MP_FUEL_VOL:            // Tankgröße
      if( Key == JBKEY_LEFT )
        {
        EEprom.Data.FuelCfgVolume -= 10;
        EEpromSave = true;
        }
      else if( Key == JBKEY_RIGHT )
        {
        EEprom.Data.FuelCfgVolume += 10;
        EEpromSave = true;
        }
                    // 1234567890123456
      sprintf( JB_Buff, "%umL", EEprom.Data.FuelCfgVolume);
      break;
    case MP_FUEL_RES:
      if( Key == JBKEY_RIGHT )
        {
        EEprom.Data.FuelCfgResAuto ^= true;
        EEpromSave = true;
        }
                    // 1234567890123456
      sprintf( JB_Buff, "%s", EEprom.Data.FuelCfgResAuto ? "auto" : "manually");
      break;

    case MP_FUEL_CNT:            // # Impulse je Liter
      if( Key == JBKEY_LEFT )
        {
        EEprom.Data.FuelCfgFlowCnt1L -= 10;
        if( EEprom.Data.FuelCfgFlowCnt1L < 0 )
          EEprom.Data.FuelCfgFlowCnt1L = 0;
        EEpromSave = true;
        }
      else if( Key == JBKEY_RIGHT )
        {
        EEprom.Data.FuelCfgFlowCnt1L += 10;
        EEpromSave = true;
        }
      else if( Key == JBKEY_LR )  // Reset auf default # Pulse
        {
        EEprom.Data.FuelCfgFlowCnt1L = FUEL_FLOWCNT_1L;
        EEpromSave = true;
        }
                    // 1234567890123456
      sprintf( JB_Buff, "%5u/L    def<>", EEprom.Data.FuelCfgFlowCnt1L);
      break;

    case MP_FUEL_CAL:             // # Impulse je Liter kalibrieren
      if( Key == JBKEY_LR )      // Start/Stop
        FuelCalActiv ^= true;
      // zyklischer Aufruf von SensorChk bei Änderungen
      if( FuelCalActiv )
        {
        SensorChk.Id = ID_FUEL_FLOW;  // Sensorcheck aktiv, Änderungen summieren
        if( SensorChk.MessureVal )
          sprintf( JB_Buff, "pulse cnt %5u", SensorChk.MessureVal);
        else               //1234567890123456
          sprintf( JB_Buff, "start flow 1L");
        }
      else if( SensorChk.MessureVal > 1000L )   // Ende der Messung, speichern
        {
        EEprom.Data.FuelCfgFlowCnt1L = SensorChk.MessureVal;
        EEpromSave = true;
                        // 1234567890123456
        sprintf( JB_Buff, "pulse cnt saved");
        }
      break;


    // Höhen Sensor
    // ----------
    #if _BMP180_  == 1
    case MP_ALT_TYP:            // Sensor Typ konfigurieren
      if( Key == JBKEY_RIGHT )
        {
        EEprom.Data.AltSensTyp++;
        if( EEprom.Data.AltSensTyp >= ARRAYCNT(SensAlt->TypTxt) )
          EEprom.Data.AltSensTyp = 0;
        EEpromSave = true;
        }
                      // 1234567890123456
      sprintf( JB_Buff, "%s", SensAlt->TypTxt[EEprom.Data.AltSensTyp]);
      break;
    #endif


    default:
      sprintf( JB_Buff, "?? MenuIdx:%d ??", MenuIdx);
      break;
    }


  // Sensor Akt/Deaktivierung
  // ------------------------
  if( IdActiv != -1 )
    {
    if( Key == JBKEY_LR )         // Änderung ?
      {
      BIT_TGL( EEprom.Data.SensActivMsk, IdActiv );
      EEpromSave = true;
      }
    sprintf( JB_Buff, "%sactiv", BIT_TST(EEprom.Data.SensActivMsk, IdActiv) ? "" : "de");
    // JB_Buff ist mit SPACE gefüllt
    JB_Buff[strlen(JB_Buff)] = ' ';               // \0 durch Space ersetzen
    if( Txt )
      {
      strcpy( &JB_Buff[JBPOS_TXT], Txt);
      JB_Buff[strlen(JB_Buff)] = ' ';             // \0 durch Space ersetzen
      }
    if( SensorChk.Id )                            // Sensor Funktionstest, Anzeige 0-9 bei jeder Änderung 
      JB_Buff[JBPOS_CHK] = (SensorChk.MessureVal%10) | '0';
    // Sensor bereits aktiviert konnte aber nicht initialisiert werden ?
    if( BIT_TST(Tele.ErrInit, IdActiv) )
      JB_Buff[JBPOS_INIT] = 'I';                  // Sensor init Fehler
    }

  if( ErrFail )                                   // Ausfall zur Laufzeit
    JB_Buff[JBPOS_FAIL] = 'F';

  JetiEx.SetJetiboxText( JetiExProtocol::LINE2, JB_Buff );

//  if( SensTstCh )                                 // Sensor Funktionstest
//    JB_Buff[JBPOS_TEST] = SensTstCh;

}




// =============================================
// Tastencode von Console in Jetibox Key wandeln
// =============================================
#if HW_TERM == 1 || SOFT_TERM == 1
uint8_t ConGetKey()
{
  uint8_t Key;

  #if HW_TERM == 1
  Key = Serial.read();
  #else
  Key = TermSoftSerial->read();
  #endif

  if ( Key == 0xff )
    return( 0 );
  //TermPutTxt("Key: ");
  //TermPutln( Key, HEX );
  if ( Key == 0x1B )              //ESC
    {
    Key = 0xff;
    delay(10);
    if ( Serial.read() == 0x5B )  // Cursor
      {
      delay(10);
      switch ( Serial.read() )    // Richtung
        {
        case 0x44: Key = JBKEY_LEFT;   break;
        case 0x43: Key = JBKEY_RIGHT;  break;
        case 0x42: Key = JBKEY_DOWN;   break;
        case 0x41: Key = JBKEY_UP;     break;
        }
      }
    }

  switch ( Key )
    {
    case JBKEY_LEFT:                // links
    case JBKEY_RIGHT:               // rechts
    case JBKEY_DOWN:                // runter
    case JBKEY_UP:                  // hoch
      break;
    case 0x0d:
      Key = JBKEY_LR;
      break;
    case 'R':
      while (1);
    default:
      Key = 0;
      break;
    }
//  TermPutTxt("KeyConv: ");
//  TermPutln( Key, HEX );

  return( Key );
}
#endif



#if SOFT_TERM == 1
void TermPut( void *Buff )
{
 uint8_t *P = Buff;

  while( *P )
    TermSoftSerial->write( *P++ );
}
#endif



