/*************************************************************
  Acceleration / G-Force Sensor
  
  Sensor: ADXL 345
  angeschlossen über I2C, A4=SDA A5=SCL
  ------------------------------------------------------------
  
  Copyright (C) 2017 Thomas Lehmann
  
  Version history:
  1.00   17.07.2017  created

***************************************************************/

#ifndef SENS_ACC_H
#define SENS_ACC_H


#include "Def.h"

// ADXL Lib
#include "Adafruit_ADXL345_U.h"



class SensorAcc
{
public:
	
  bool Init( uint8_t Id, int8_t CfgCalX, int8_t CfgCalY, int8_t CfgCalZ, int8_t CfgCalPitch, int8_t CfgCalRoll );
  void Tim10mS();

  // Telemetriewerte
  struct
    {
    float  GForceX;                        // G-Force X-Achse / Querruder
    float  GForceY;                        // G-Force Y-Achse / Höhenruder
    float  GForceZ;                        // G-Force Z-Achse / Seitenruder
    long   Pitch;                          // 
    long   Roll;                           // 
    }TVal;

private:

  Adafruit_ADXL345_Unified  *Accel;

  // Kalibrierungswerte Accelerator / G-Forc
  float CalX;
  float CalY;
  float CalZ;
  float CalPitch;
  float CalRoll;

  uint8_t TmoRefresh;
    #define ACC_TMO_REFRESH  (100/TIM_BASE)  // alle 100mS eine Messung vornehmen

};

#endif




